# Policy service

Policy service is used for management and evaluation of dynamic policies in OSDU. 

## Dependencies
Policy service has a runtime dependency on Open Policy Agent [OPA](https://openpolicyagent.org/).
It also has a runtime dependency on OSDU entitlements service for API authorization.

## Environmental variables
_ENTITLEMENTS_BASE_URL_ and _LEGAL_BASE_URL_ environmental variable must be set to run the service. The values provided should be of format _scheme://host[:port]_ and not include any part of path (e.g., https://entitlements.osdu.compay.com).

## API authorization
To read or evaluate policies, user calling the policy service, must be a member of _service.policy.user_ or _service.policy.admin_ group.

To create, update, or delete the policies, user must be a member of _service.policy.admin_ group.

User can be added to these groups by using entitlements service.

For information on how to run the policy service:
[Policy Service README](./app/README.md)

For information on testing the policy service:
[Test Policy Service README](./app/tests/README.md)

API documentation:
[OpenAPI](./docs/openapi.yaml)

There is also a Policy Service Admin CLI:
[Policy Service Admin CLI](./frontend/admincli/README.md)

There is also a Policy Service Admin UI POC:
[Policy Service Admin UI](./frontend/adminui/README.md)
