import os

#  ENTITLEMENTS_BASE_URL is the https/http endpoint for entitlement service
ENTITLEMENTS_GROUPS_API = os.getenv('ENTITLEMENTS_BASE_URL', 'http://entitlements') + \
    os.getenv('ENTITLEMENTS_BASE_PATH', '/api/entitlements/v2/groups')
LEGAL_BATCH_API = os.getenv('LEGAL_BASE_URL','http://legal-service') + '/api/legal/v1/legaltags:batchRetrieve'
LEGAL_BASE_URL = os.getenv('LEGAL_BASE_URL')
# Partition API is only used in testing
PARTITION_API = os.getenv('PARTITION_BASE_URL','http://partition') + '/api/partition/v1'

# Diagnostics should never be enabled in true production environments
ENABLE_DEV_DIAGNOSTICS = False
if "ENABLE_DEV_DIAGNOSTICS" in os.environ:
    ENABLE_DEV_DIAGNOSTICS = True

# Diagnostics should never be enabled in true production environments
# Create DUMP outputs - for troubleshooting eval, etc
ENABLE_DEV_DIAGNOSTICS_DUMPS = False
if "ENABLE_DEV_DIAGNOSTICS_DUMPS" in os.environ:
    ENABLE_DEV_DIAGNOSTICS_DUMPS = True

localhost_opa_url = 'http://localhost:8181'
OPA_URL = os.getenv('OPA_URL', localhost_opa_url)
if len(OPA_URL) == 0:
    OPA_URL = localhost_opa_url

# OPA APIs
OPA_POLICIES_API = OPA_URL + '/v1/policies'
OPA_DATA_API = OPA_URL + '/v1/data'
OPA_COMPILE_API = OPA_URL + '/v1/compile'
OPA_CONFIG_API = OPA_URL + '/v1/config'
OPA_HEALTH_API = OPA_URL + '/health'
OPA_STATUS_API = OPA_URL + '/v1/status'

USE_BUNDLES = os.getenv("USE_BUNDLES", True)

# Require users and admin to be in these groups
USER_PERMISION = 'service.policy.user'
ADMIN_PERMISION = 'service.policy.admin'

# Admin UI
ENABLE_ADMIN_UI = False
if "ENABLE_ADMIN_UI" in os.environ:
    ENABLE_ADMIN_UI = True

# OPA bug in OPA Version: 0.43.0 where policy IDs are get a leading /
OPA_BUG_FORCE_SLASH=False

# Prefix for all policy service APIs
SERVICE_BASE_PATH = "/api/policy/v1"

INSTANCE_BUNDLE_ROOT = "osdu/instance"
PARTITION_BUNDLE_ROOT = "osdu/partition/{0}"

# support local testing and mock
LOCAL="LOCAL"
MOCK="MOCK"

# Generate a Correlation ID when one is not provided in request
GENERATE_CORRELATION_ID = True

RESPONSE_HEADERS_STRICT_TRANSPORT_SECURITY = "max-age=31536000; includeSubDomains"
RESPONSE_HEADERS_CONTENT_SECURITY_POLICY = "frame-ancestors 'none'"
RESPONSE_HEADERS_X_CONTENT_TYPE_OPTIONS = "nosniff"
RESPONSE_HEADERS_CACHE_CONTROL = "no-store"
RESPONSE_HEADERS_X_FRAME_OPTIONS = "DENY"
