# Automated Unit and Integration tests
* template directory - these are read in and modified during testing
* instance_data - these are policies that are expected to be in bundle to support testing
* data - manual testing data folder

Please Note:
* pytest will both run a local copy of the policy service and connect to service_url.
* if OPA access option --opa_access is given, it is expected that the local copy of the policy service will have access to OPA. Without this option some tests will be skipped.
* Tests also require at least one legal tag to be present for the data_partition given.
* python must be python version 3.9.x, recommend 3.9.13 or later

To run unit or integration tests the following ENV variables are required:
* CLOUD_PROVIDER
* OPA_URL
* BUNDLE_PAUSE (or --bundle_pause arg) - this value should be at least 2.5x the value of max_delay_seconds polling in OPA init.yaml. For example if using 12 seconds for max_delay_seconds, I'd recommend using 30 seconds BUNDLE_PAUSE. This forces the integration tests to sleep while waiting for async process of OPA to read from bundle service. Failure to adjust this for your environment will cause integration tests to fail.
* TOKEN (or --token arg)
* DATA_PARTITION (or --data_partition arg)
* ENTITLEMENTS_BASE_URL
* LEGAL_BASE_URL
* DOMAIN (or --domain arg)

Potentially required args:
* --service_url arg (or will default to http://localhost:8080) where policy service is running. Do not include /api/policy/... in service_url should only be http/https host and port.

CSP related ENV variables:
* POLICY_BUCKET
* CONTAINER_NAME
* STORAGE_ACCOUNT

Other environment variables:
* PYTHONPATH may be required to point to policy/app directory

Optional:
* ENABLE_DEV_DIAGNOSTICS if this is set while running service, you may also set this env variable for additional tests. This will also enable dumping of json for development and additional debugging.  NOTE: ENABLE_DEV_DIAGNOSTICS should never be used in production.
* --durations=3 will show the slowest 3 tests. These should be the 2 test_wait_for_bundle tests and you other slowest

integration/test_integration_015_legal.py::test_create_legal_tag creates a legal tag to cover the use case/testing when it's a new data partition without legal tags. This may require users.datalake.editors group or users.datalake.admin or the like.

#### Templates:
Depending on the test the following may be used in the template .json and .rego files
* ${data_partition} - OSDU data partition (from --data_partition or DATA_PARTITION env var)
* ${legal_tag} - a random legal tag looked up from legal service
* ${name} - policy name
* ${domain} - domain name (from --domain or DOMAIN env var)
