#!/bin/bash
set -ex
# move to the root of the repo
cd $CI_PROJECT_DIR
#auth steps
echo $OSDU_GCP_INTEGRATION_TESTER | base64 -d > OSDU_GCP_INTEGRATION_TESTER.json
gcloud auth activate-service-account --key-file OSDU_GCP_INTEGRATION_TESTER.json
gcloud config set project $OSDU_GCP_PROJECT
export GOOGLE_APPLICATION_CREDENTIALS="$CI_PROJECT_DIR/OSDU_GCP_INTEGRATION_TESTER.json"
echo $GOOGLE_APPLICATION_CREDENTIALS
export BEARER_TOKEN=`gcloud auth print-access-token`

#prepare steps
apk add py3-pip
pip install -r requirements.txt
pip install -r requirements_dev.txt
cd app
pip install -r requirements.txt

#run tests
python3 -m pytest --token=$BEARER_TOKEN --service_url=$HOST --data_partition=$DATA_PARTITION