#!/usr/bin/env bash
# from tests/ibm/ goes up to the tests dir.
cd ../../
# Install venv for python3
sudo apt-get update && sudo apt-get install -y python3 python3-pip python3-venv && sudo apt-get install python3-venv --fix-missing

python3 --version
python3 -m venv env
source env/bin/activate
python3 -m pip install --upgrade pip
python3 -m pip install -r requirements.txt
python3 -m pip install wheel pytest pytest-cov

echo First_URL $IBM_POLICY_BASE_URL
echo First_OPA_URL $OPA_URL
export BUNDLE_PAUSE=130
export DATA_PARTITION="opendes"
export CLOUD_PROVIDER="ibm"
export ENTITLEMENTS_BASE_URL=$IBM_POLICY_BASE_URL
export LEGAL_BASE_URL=$IBM_POLICY_BASE_URL
export OPA_URL=$IBM_OPA_URL
export IBM_POLICY_SERVICE_URL=$IBM_POLICY_BASE_URL
export DOMAIN="ibm.com"
echo BUNDLE_PAUSE $BUNDLE_PAUSE
echo ENTITLEMENTS_BASE_URL $ENTITLEMENTS_BASE_URL
echo LEGAL_BASE_URL $LEGAL_BASE_URL
echo OPA_URL $OPA_URL
echo CLOUD_PROVIDER $CLOUD_PROVIDER
echo DOMAIN $DOMAIN
echo IBM_POLICY_SERVICE_URL $IBM_POLICY_BASE_URL
echo DATA_PARTITION $DATA_PARTITION

svctoken=$(python3 tests/ibm/ibm_jwt_client.py)
python3 -m pytest --token="$svctoken" --service_url=$IBM_POLICY_BASE_URL --data_partition=$DATA_PARTITION
