# test_integration_020_put.py
import pytest
# requires pytest_dependency to be installed
import unittest
import responses
from fastapi.testclient import TestClient
import requests
import re
import logging
import sys
import os
import base64
import json
import time
from pathlib import Path

# so the directly in which you run pytest or unittest doesn't matter as much
sys.path.append(os.path.abspath('..'))
sys.path.append('tests')

# local
from main import app
from auth import auth
import conf
import testlib

# override dependency injection for authentication to entitlement service
from override_depends import override_require_authorized_user, set_authorize_session, ADMIN_ONLY_SVC, USER_AND_ADMIN_SVC, USER_ONLY_SVC, OTHER_ONLY_SVC

TEST_DATA_DIR = Path(__file__).resolve().parent / '../templates'

client = TestClient(app)

@pytest.mark.dependency(name="require_token")
def test_require_token(token):
    assert token is not None, "No token provided on command line"

@pytest.mark.dependency(depends=["require_token"])
def test_put_policies_test_data_mock(token, data_partition, domain):
    assert token is not None, "No token provided on command line"
    testlib.put_policies_test_data(client=client, token=token, data_partition=data_partition, domain=domain)

@pytest.mark.dependency(depends=["require_token"])
def test_put_policies_test_data_service_url(token, data_partition, service_url, domain):
    assert token is not None, "No token provided on command line"
    testlib.put_policies_test_data(client=requests,
         token=token,
         data_partition=data_partition,
         service_url=service_url,
         domain=domain)
