import sys
import os
import pytest
from typer.testing import CliRunner
sys.path.append(os.path.abspath('..'))
from pol import cli

runner = CliRunner()

@pytest.mark.skipif(sys.version_info == (3, 9), reason="requires python3.9")

# Test all the helps
# Help for Policy Commands
def test_cli_help():
    result = runner.invoke(cli, ["--help"])
    assert result.exit_code == 0

@pytest.mark.parametrize("test_input", [("ls"), ("add"), ("rm"), ("eval"), ("health"), ("translate")])
def test_cli_policy_help(test_input):
    result = runner.invoke(cli, [test_input, "--help"])
    assert result.exit_code == 0, f"exit status, stdout: {result.stdout}"

# Help for Policy Developer Utils/Commands
@pytest.mark.parametrize("test_input", [("diff"), ("compile"), ("opa-add"), ("opa-rm"), ("health"), ("translate")])
def test_cli_devutil_help(test_input):
    result = runner.invoke(cli, [test_input, "--help"])
    assert result.exit_code == 0, f"exit status, stdout: {result.stdout}"

# Help for Utils/Commands
@pytest.mark.parametrize("test_input", [("info"), ("search"), ("storage")])
def test_cli_util_help(test_input):
    result = runner.invoke(cli, [test_input, "--help"])
    assert result.exit_code == 0, f"exit status, stdout: {result.stdout}"