import sys
import os
import pytest
from typer.testing import CliRunner
sys.path.append(os.path.abspath('..'))
from pol import cli

runner = CliRunner()

@pytest.mark.skipif(sys.version_info == (3, 9), reason="requires python3.9")

@pytest.mark.parametrize("policy_name", [("example"), ("example2")])
def test_cli_policy_rm(policy_name, data_partition):
    result = runner.invoke(cli, ["ls", policy_name, "--quiet"])
    if result.exit_code:
        pytest.xfail(f"Policy {policy_name} not found in data_partition {data_partition}")
    result = runner.invoke(cli, ["rm", policy_name, "--force"])
    assert result.exit_code == 0, f"stdout: {result.stdout}"